//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "mainUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TfrmMain *frmMain;


/** \brief Struktura zwizana z sortowanie TListView */
typedef struct tagSORTINFO
{
    int column;     ///< numer kolumny
    bool forward;   ///< kierunek sortowania
    int kind;		///< rodzaj sortowania: 0 - tekstowe, 1 - numeryczne, 2 - date/time
} SORTINFO, FAR *LPSORTINFO;
// callback function prototype dla sortowania TListView
int CALLBACK CustomSortProcedure(long lParam1, long lParam2, long lParamSort);



//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::Button1Click(TObject *Sender)
{
    TListItem *item;
	int startPerformanceMeas = GetTickCount();

    if(chbBeginUpdate->Checked)
	    ListView1->Items->BeginUpdate();
    if(chbStyle->Checked)
    	ListView1->ViewStyle = vsList;
    ListView1->Clear();
	for(int i=0; i<CSpinEdit1->Value; i++)
    {
		item = ListView1->Items->Add();
        item->ImageIndex = -1;
        item->Caption = IntToStr(i);
        item->SubItems->Add((AnsiString)"SubItem0_" + IntToStr(i));
        item->SubItems->Add((AnsiString)"SubItem1_" + IntToStr(i));
        item->SubItems->Add((AnsiString)"SubItem2_" + IntToStr(i));
    }
    if(chbBeginUpdate->Checked)
	    ListView1->Items->EndUpdate();
    if(chbStyle->Checked)
    	ListView1->ViewStyle = vsReport;
    int executionTime = GetTickCount() - startPerformanceMeas;
    lblTime->Caption = IntToStr(executionTime);
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::CSpinEdit1Change(TObject *Sender)
{
	ListView2->Items->Count = CSpinEdit1->Value;
    ListView2->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::ListView2Data(TObject *Sender, TListItem *Item)
{
    int i = Item->Index;
    Item->ImageIndex = -1;
    Item->Caption = IntToStr(i);
    Item->SubItems->Add((AnsiString)"SubItem0_" + IntToStr(i));
    Item->SubItems->Add((AnsiString)"SubItem1_" + IntToStr(i));
    Item->SubItems->Add((AnsiString)"SubItem2_" + IntToStr(i));
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::CSpinEdit2Change(TObject *Sender)
{
	ListView1->AllocBy = CSpinEdit2->Value;	
}
//---------------------------------------------------------------------------




/** \brief Sortowanie danych w komponentach typu TListView */
int CALLBACK CustomSortProcedure(long lParam1, long lParam2, long lParamSort)
{ 
    LPSORTINFO si = (SORTINFO *)lParamSort; 
    TListItem *Item1 = (TListItem *)lParam1; 
    TListItem *Item2 = (TListItem *)lParam2; 

    AnsiString first, second; 
    // if it's the first column, sort by Item->Caption 
    try
    {
        if (si->column == 0)
        {
            first = Item1->Caption;
            second = Item2->Caption;
        }

        // otherwise sort by SubItems->Strings[]
        else
        {
            first = Item1->SubItems->Strings[si->column - 1];
            second = Item2->SubItems->Strings[si->column - 1];
        }
        if(si->kind == 1)	//sortowanie numeryczne
        {
        	if(si->forward)
            	return atoi(first.c_str()) - atoi(second.c_str());	//atoi jest odporne na bdy konwersji
            else
            	return atoi(second.c_str()) - atoi(first.c_str());
        }
        if(si->kind == 2)	//sortowanie wg czasu - uzupenienie zera wiodcego,
        {
            if(first.Length() < second.Length())
            	first = (AnsiString)"0" + first;
            if(first.Length() > second.Length())
            	second = (AnsiString)"0" + second;
        	// use the AnsiCompare method to do all the work
        	if (si->forward) return first.AnsiCompare(second);
        	else return second.AnsiCompare(first);
        }
        else	//sortowanie tekstowe
        {
        	// use the AnsiCompare method to do all the work
        	if (si->forward) return first.AnsiCompare(second);
        	else return second.AnsiCompare(first);
        }
    }
    catch(Exception &exception)
    {
    	return 0;
    }
}


void __fastcall TfrmMain::ListViewColumnClick(TObject *Sender,
      TListColumn *Column)
{
    int index = Column->ImageIndex;	//zapamitanie sposobu sortowania kolumny
    SORTINFO si;
    si.column = Column->Index;
    si.kind = Column->Tag;			//w tagu kolumny przechowywana jest informacja w jaki sposb naley j sortowa (tekstowo/numerycznie/...)
    //zmiana kierunku sortowania po klikniciu
    if(index <= 0)
    	si.forward = true;
    else
    	si.forward = false;	//sortowanie wstecz
    //si.forward = CheckBox1->Checked; // adjust accordingly
    TListView* lista = (TListView*)Sender;
    lista->CustomSort(CustomSortProcedure, (LPARAM)&si);
    for(int i=0; i<lista->Columns->Count; i++)
    	lista->Column[i]->ImageIndex = -1;
    if(index > 0)
    	Column->ImageIndex = 0;
    else
    	Column->ImageIndex = 1;	//sortowanie wstecz
    if(Sender)
    	((TListView*)Sender)->Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::FormShow(TObject *Sender)
{
	CSpinEdit1Change(NULL);		
}
//---------------------------------------------------------------------------
